package org.openxma.dsl.platform.hibernate.hql.impl;

import antlr.TokenWithIndex;

public class HqlTokenWithIndex extends TokenWithIndex {
	private boolean possibleID = false;
	private int tokenType;

	/**
	 * @return True if the token could be interpreted as in identifier, false if
	 *         not.
	 */
	public boolean isPossibleID() {
		return possibleID;
	}

	/**
	 * Sets the type of the token, remembering the previous type.
	 * 
	 * @param t
	 *            The new token type.
	 */
	public void setType(int t) {
		this.tokenType = getType();
		super.setType(t);
	}

	/**
	 * @return int - The old token type.
	 */
	private int getPreviousType() {
		return tokenType;
	}

	/**
	 * Set to true if this token can be interpreted as an identifier, false if
	 * not.
	 * 
	 * @param possibleID
	 *            True if this is a keyword/identifier, false if not.
	 */
	public void setPossibleID(boolean possibleID) {
		this.possibleID = possibleID;
	}

	/**
	 * Returns a string representation of the object.
	 * 
	 * @return String - The debug string.
	 */
	public String toString() {
		return "[\"" + getText() + "\",<" + getType() + "> previously: <" + getPreviousType() + ">,line=" + line + ",col="
				+ col + ",possibleID=" + possibleID + "]";
	}

}
