/*******************************************************************************
 * Copyright (c) 2010 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/
package org.openxma.dsl.platform.query.impl;

import org.openxma.dsl.platform.query.Expression;
import org.openxma.dsl.platform.query.ExpressionOperator;

/**
 * An operator expression with one operand.
 */
public abstract class UnaryExpression extends Expression {
    private static final long serialVersionUID = 1L;
    private Expression expression;
    private ExpressionOperator operator;

    public UnaryExpression(Expression expression, ExpressionOperator operator) {
        super();
        this.parent = expression.getParent();
        this.expression = expression;
        this.expression.setParent(this);
        this.operator = operator;
    }

    public Expression getExpression() {
        return expression;
    }


    public ExpressionOperator getOperator() {
        return operator;
    }


    @Override
    public String toString() {
        return this.expression.toString() + " " + this.operator.toString();
    }

}
