package org.openxma.dsl.platform.valueobject;

import java.math.BigDecimal;

public class ValueObjectBigDecimal extends ValueObjectComparable<BigDecimal> {

    private static final long serialVersionUID = 1L;

    public ValueObjectBigDecimal(BigDecimal value) {
        super(value);
    }

    public static ValueObjectBigDecimal newOrNull(BigDecimal value) {
        if (value != null) {
            return new ValueObjectBigDecimal(value);
        }
        return null;
    }

    public static ValueObjectBigDecimal newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new ValueObjectBigDecimal(new BigDecimal(value));
        }
        return null;
    }

}

