package org.openxma.dsl.platform.xma;

import java.util.Iterator;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.page.Page;
import at.spardat.xma.session.XMASessionServer;

abstract public class DslComponentServer extends ComponentServer {

	public DslComponentServer() {
		super();
	}

	public DslComponentServer(XMASessionServer session, boolean isStateless,
			short id) {
		super(session, isStateless, id);
	}
	
	/**
	 * Calls the method modelToInstanceData() of each page of the XMAComponent.
	 */
    public void modelToInstanceData() {
		Iterator pagesIterator = getPageModels();
		while (pagesIterator.hasNext()) {
			Page page = (Page)pagesIterator.next();
			if (page instanceof DslPageServer) {
				DslPageServer dslPage = (DslPageServer)page;
				dslPage.modelToInstanceData();				
			}
		}    	
    }

	/**
	 * Calls the method instanceDataToModel() of each page of the XMAComponent.
	 */    
    public void instanceDataToModel() {
		Iterator pagesIterator = getPageModels();
		while (pagesIterator.hasNext()) {
			Page page = (Page)pagesIterator.next();
			if (page instanceof DslPageServer) {
				DslPageServer dslPage = (DslPageServer)page;
				dslPage.instanceDataToModel();				
			}
		}    	    	
    }	

}
